#using <mscorlib.dll>
#ifndef FILEINARCHIVE
#define FILEINARCHIVE

#include <time.h>
#include "Unmanaged.h"

using namespace System;

namespace HongliangSoft {
  namespace Utilities {
    public __gc class FileInArchive {
    private :
      String* archiveFile;
      String* compressedMethod;
      int position;
      int compressedSize;
      int fileSize;
      DateTime lastWriteTime;
      String* path;
      String* fileName;
      int crc;
    private public :
      FileInArchive(String* archiveFile, FILEINFO* info) {
        this->archiveFile = archiveFile;
        this->compressedMethod = new String((char*)info->method);
        this->position = info->position;
        this->compressedSize = info->compsize;
        this->fileSize = info->filesize;
        tm* t = localtime(&info->timestamp);
        this->lastWriteTime = DateTime(t->tm_year + 1900, t->tm_mon + 1, t->tm_mday,
                                       t->tm_hour, t->tm_min, t->tm_sec);
        this->path = new String((char*)info->path);
        this->fileName = new String((char*)info->filename);
        this->crc = info->crc;
      }
      __property int get_Position() { return this->position; }
    public :
      __property String* get_ArchiveFile() { return this->archiveFile; }
      __property String* get_CompressedMethod() { return this->compressedMethod; }
      __property int get_CompressedSize() { return this->compressedSize; }
      __property int get_FileSize() { return this->fileSize; }
      __property DateTime get_LastWriteTime() { return this->lastWriteTime; }
      __property String* get_Path() { return this->path; }
      __property String* get_FileName() { return this->fileName; }
      __property UINT get_CRC() { return this->crc; }
      __property bool get_IsDirectory() { return this->fileName == "" && this->fileSize == 0; }
    };
  }
}
#endif