#ifndef SUSIEPICTUREWRAPPER
#define SUSIEPICTUREWRAPPER

#include <windows.h>
#include "SusieWrapper.h"
#include "PictureInfo.h"
#include "Unmanaged.h"
#include "ProgressCallback.h"
#using <mscorlib.dll>
#using <System.dll>
#using <System.Drawing.dll>
using namespace System;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;
using namespace System::IO;

namespace HongliangSoft {
  namespace Utilities {
    public __gc class SusiePictureWrapper : public SusieWrapper {
    private :
      GetPictureInfoHandler getPictureInfoHandler;
      GetPictureHandler getPictureHandler;
      GetPictureHandler getPreviewHandler;
      Bitmap* GetBitmap(String* filePath, GetPictureHandler handler, ProgressCallback* callback);
      Bitmap* GetBitmap(Stream* stream, GetPictureHandler handler, ProgressCallback* callback);
      Bitmap* GetBitmap(void* ptr, int size, int flags, GetPictureHandler handler, ProgressCallback* callback);
      static Byte GetBytes(Stream* stream) __gc[];
      __property bool get_CanGetPictureInfo() { return getPictureInfoHandler != NULL; }
      __property bool get_CanGetPicture() { return getPictureHandler != NULL; }
      __property bool get_CanGetPreview() { return getPreviewHandler != NULL; }
    private public :
      SusiePictureWrapper(HMODULE module);
    protected :
      void Dispose(bool disposing);
    public :
      PictureInfo* GetPictureInfoFromFile(String* filePath);
      PictureInfo* GetPictureInfoFromFileImage(IntPtr memoryAddress, long size);
      Bitmap* GetPictureFromFile(String* filePath);
      Bitmap* GetPictureFromFile(String* filePath, ProgressCallback* callback);
      Bitmap* GetPictureFromStream(Stream* image);
      Bitmap* GetPictureFromStream(Stream* image, ProgressCallback* callback);
      Bitmap* GetPreviewFromFile(String* filePath);
      Bitmap* GetPreviewFromFile(String* filePath, ProgressCallback* callback);
      Bitmap* GetPreviewFromStream(Stream* image);
      Bitmap* GetPreviewFromStream(Stream* image, ProgressCallback* callback);
    };
  }
}
#endif