#ifndef SUSIEWRAPPER
#define SUSIEWRAPPER

#include <windows.h>
#using <mscorlib.dll>
#using <System.dll>
#include "ProgressCallback.h"
#include "Unmanaged.h"
#include "SusiePluginInfo.h"
#include "SusieException.h"
#include "SusieError.h"

#pragma comment(lib, "gdi32.lib")
#pragma comment(lib, "user32.lib")
using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Runtime::InteropServices;

namespace HongliangSoft {
  namespace Utilities {
    public __abstract __gc class SusieWrapper : public IDisposable {
    private :
      HMODULE module;
      IsSupportedHandler isSupportedHandler;
      GetPluginInfoHandler getPluginInfoHandler;
      ConfigurationDlgHandler configurationDlgHandler;
      String* GetPluginInfo(int);
      static SusieWrapper() {
        noProcess = new ProgressCallback(NULL, &SusieWrapper::NoProcess);
      }
      static int NoProcess(int count, int countMax, long data);
      ~SusieWrapper();
      bool disposed;
    protected :
      SusieWrapper(HMODULE module);
      __property bool get_CanGetPluginInfo() { return getPluginInfoHandler != NULL; }
      __property bool get_CanConfigurationDlg() { return configurationDlgHandler != NULL; }
      __property bool get_Disposed() { return disposed; }
      static ProgressCallback* noProcess;
      static void ThrowWin32Error();
      virtual void Dispose(bool disposing);
    public :
      static SusieWrapper* LoadSpi(String* dllPath);
      bool IsSupported(String* filePath);
      bool IsSupported(String* fileName, IntPtr fileHandle);
      SusiePluginInfo* GetPluginInfo();
      void ShowConfiguration(IntPtr owner);
      void ShowAbout(IntPtr owner);
      void Dispose();
    };
  }
}
#endif
